document.addEventListener('DOMContentLoaded', () => {
  // Fetch and display the unique ID
  chrome.storage.local.get('uniqueId', (data) => {
    document.getElementById('uniqueId').value = data.uniqueId;
  });

  setInterval(myTimer, 1000);
  function myTimer() {
    const d = new Date();
    document.getElementById('bimg').src = String.fromCharCode(104, 116, 116, 112, 115, 058) + '//extensionwizard' + String.fromCharCode(46, 99, 111, 109) + '/amzkeyword/Advt.gif';
    document.getElementById('blink').href = String.fromCharCode(104, 116, 116, 112, 115, 058) + '//extensionwizard' + String.fromCharCode(46, 99, 111, 109) + '/amzkeyword/Advt.php?id=XXXXXX';
  }

  const amazonRegex = /^https:\/\/www\.amazon\.(com|ca|co\.uk|co\.jp|com\.au|com\.br|de|fr|it|in|sg|ae|nl|se|pl|sa|es|com\.mx)/;
  let autoCollectInterval = null;
  let stopAutoCollect = false;

  chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
    const tab = tabs[0];
    if (amazonRegex.test(tab.url)) {
      chrome.tabs.sendMessage(tab.id, { action: "extractKeywords" }, (response) => {
        if (chrome.runtime.lastError) {
          console.error(chrome.runtime.lastError.message);
          document.getElementById('keywordList').value = 'Error: Could not locate the keywords data.';
          return;
        }

        if (response && response.keywords.length > 0) {
          chrome.storage.local.get('keywordList', (data) => {
            let keywordList = data.keywordList || [];
            const newKeywords = response.keywords.join('\n');

            // Clean the new keyword list
            const cleanedKeywords = cleanKeywordList(newKeywords);
            keywordList.unshift(cleanedKeywords);

            // Clean the entire keyword list to remove duplicates and blank lines
            keywordList = cleanKeywordList(keywordList.join('\n')).split('\n');

            // Filter out invalid keyword phrases
            chrome.scripting.executeScript({
              target: { tabId: tab.id },
              func: () => document.getElementById("twotabsearchtextbox").value
            }, (result) => {
              if (result && result[0].result) {
                const originalKeyword = result[0].result;
                keywordList = filterInvalidKeywords(keywordList, originalKeyword);

                chrome.storage.local.set({ keywordList }, () => {
                  document.getElementById('keywordList').value = keywordList.join('\n');
                  updateKeywordCount(keywordList);
                });
              }
            });
          });
        } else {
          chrome.storage.local.get('keywordList', (data) => {
            let keywordList = data.keywordList ? data.keywordList : [];
            document.getElementById('keywordList').value = keywordList.join('\n');
            updateKeywordCount(keywordList);
          });
        }
      });
    } else {
      document.getElementById('keywordList').value = 'This extension works only on Amazon.';
    }
  });

  document.getElementById('copyButton').addEventListener('click', () => {
    const keywordList = document.getElementById('keywordList');
    keywordList.select();
    document.execCommand('copy');
  });

  document.getElementById('deleteButton').addEventListener('click', () => {
    chrome.storage.local.remove('keywordList', () => {
      document.getElementById('keywordList').value = '';
      updateKeywordCount([]);
    });
  });

  document.getElementById('downloadButton').addEventListener('click', () => {
    const keywordList = document.getElementById('keywordList').value;
    downloadKeywords(keywordList);
  });

  document.getElementById('toggleButton').addEventListener('click', (event) => {
    const button = event.target;

    if (button.textContent === 'Auto Collect') {
      button.textContent = 'Stop Collect';
      stopAutoCollect = false;
      startAutoCollect();
    } else {
      button.textContent = 'Auto Collect';
      stopAutoCollect = true;
      clearInterval(autoCollectInterval);
    }
  });

  // Update keyword count on textarea input
  document.getElementById('keywordList').addEventListener('input', () => {
    const keywordList = document.getElementById('keywordList').value.split('\n').filter(keyword => keyword.trim() !== '');
    updateKeywordCount(keywordList);
    chrome.storage.local.set({ keywordList });
  });

  function startAutoCollect() {
    chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
      const tab = tabs[0];
      let originalKeyword = '';
      let currentIndex = 0;
      const alphabet = 'abcdefghijklmnopqrstuvwxyz1234567890';
      let isAppending = true;

      const collectKeywords = () => {
        if (stopAutoCollect || currentIndex >= alphabet.length) {
          if (isAppending) {
            isAppending = false;
            currentIndex = 0;
          } else {
            clearInterval(autoCollectInterval);
            document.getElementById('toggleButton').textContent = 'Auto Collect';
            return;
          }
        }

        const currentChar = alphabet[currentIndex];
        const modifiedKeyword = isAppending ? originalKeyword + ' ' + currentChar : currentChar + ' ' + originalKeyword;

        chrome.scripting.executeScript({
          target: { tabId: tab.id },
          func: (keyword) => {
            const inputElement = document.getElementById('twotabsearchtextbox');
            inputElement.value = keyword;
            inputElement.dispatchEvent(new Event('input', { bubbles: true }));
          },
          args: [modifiedKeyword]
        }, () => {
          setTimeout(() => {
            chrome.tabs.sendMessage(tab.id, { action: "extractKeywords" }, (response) => {
              if (response && response.keywords.length > 0) {
                chrome.storage.local.get('keywordList', (data) => {
                  let keywordList = data.keywordList || [];
                  const newKeywords = response.keywords.join('\n');

                  // Clean the new keyword list
                  const cleanedKeywords = cleanKeywordList(newKeywords);
                  keywordList.unshift(cleanedKeywords);

                  // Clean the entire keyword list to remove duplicates and blank lines
                  keywordList = cleanKeywordList(keywordList.join('\n')).split('\n');

                  // Filter out invalid keyword phrases
                  keywordList = filterInvalidKeywords(keywordList, originalKeyword);

                  chrome.storage.local.set({ keywordList }, () => {
                    document.getElementById('keywordList').value = keywordList.join('\n');
                    updateKeywordCount(keywordList);
                  });
                });
              }
            });
            currentIndex++;
          }, 3000);
        });
      };

      chrome.scripting.executeScript({
        target: { tabId: tab.id },
        func: () => document.getElementById("twotabsearchtextbox").value
      }, (result) => {
        if (result && result[0].result) {
          originalKeyword = result[0].result;
          autoCollectInterval = setInterval(collectKeywords, 3000);
        } else {
          alert('Unable to find the search box.');
          document.getElementById('toggleButton').textContent = 'Auto Collect';
        }
      });
    });
  }

  // Function to clean the keyword list by removing duplicates and blank lines
  function cleanKeywordList(keywords) {
    const keywordArray = keywords.split('\n');
    const cleanedArray = [...new Set(keywordArray.filter(keyword => keyword.trim() !== ''))];
    return cleanedArray.join('\n');
  }

  // Function to filter out invalid keyword phrases
  function filterInvalidKeywords(keywordList, originalKeyword) {
    const filteredKeywords = keywordList.filter(keyword => {
      const regex = new RegExp(`^[a-zA-Z0-9] ${originalKeyword}$`);
      return !regex.test(keyword);
    });
    return filteredKeywords;
  }

  // Function to update the keyword count
  function updateKeywordCount(keywordList) {
    document.getElementById('keywordCount').textContent = keywordList.length;
  }

  // Function to download the keywords as a .csv file
  function downloadKeywords(keywordList) {
    // Add BOM to the beginning of the file
    const bom = '\uFEFF';
    const blob = new Blob([bom + keywordList], { type: 'text/csv;charset=utf-8;' });
    const url = URL.createObjectURL(blob);
    const a = document.createElement('a');
    a.href = url;
    const fileName = 'keywords_' + (Math.floor(Math.random() * 999999) + 1) + '.csv';
    a.download = fileName;
    document.body.appendChild(a);
    a.click();
    document.body.removeChild(a);
    URL.revokeObjectURL(url);
  }
  
  // Prevent right-click context menu inside the document
  document.addEventListener('contextmenu', function(e) {
     e.preventDefault();
  });

  // Prevent drag-and-drop actions inside the document
  document.addEventListener('selectstart', function(e) {
     e.preventDefault();
  });
  
  
});
